//=================================================================================================
//  ORBvar饹(١饹)ڤӡ RT ݡͥȥȥ륯饹
//
//  date   : 20080720 first
//  date   : 20080721 update
//
//  Author : Takashi KOJIMA, Chuo University
//
//=================================================================================================
#ifndef INTERFACE_CONTROL_RT_COMPONENT_MODEL_CLASS
#define INTERFACE_CONTROL_RT_COMPONENT_MODEL_CLASS

#include <iostream>
#include <string>
#include <rtm/CorbaNaming.h>
#include <rtm/RTObject.h>
#include <assert.h>

//! manage ORB_var class
/**
* CORBA::ORB_var륯饹<BR>
* CORBA::ORB_varauto_ptrΤ褦˼ưŪΰƤ餷
*/
class ORBvarManager
{
	private:
	bool                           m_delete;         //!< ORB_va delete flag
	static long                    s_exist_cnt;      //!< exist count

	public:
	static CORBA::ORB_var          s_orb;            //!< omni's pointer
	//! 󥹥ȥ饯
	ORBvarManager(bool idelete = false)
	:m_delete(idelete)
	{
		if(s_exist_cnt == 0)ORBInit();
		s_exist_cnt++;
	};
	//! ǥȥ饯
	virtual ~ORBvarManager();

	//! Initilize ORB_var
	void static ORBInit()
	{
		if(s_exist_cnt > 0)return;
	  int    argc(0);
	  char** argv(0);
		s_orb = CORBA::ORB_init(argc, argv);
	};
	//! ORB destroy
	void static ORBdestroy()
	{
		if(s_exist_cnt != 0)return;
		std::cout << __FUNCTION__ << std::endl;
		s_orb->destroy();
	};
};
CORBA::ORB_var ORBvarManager::s_orb;
long           ORBvarManager::s_exist_cnt(0);

ORBvarManager::~ORBvarManager()
{
	s_exist_cnt--;
	if(s_exist_cnt == 0 && m_delete)ORBdestroy();
}


//!RT component control class
class RTCompControl : public ORBvarManager
{
	public:
	//!ǥեȥ󥹥ȥ饯
	RTCompControl(std::string OmniNameServerName,long port = -1)
	:ORBvarManager(),m_nameserver(s_orb,NameAndPort2str(OmniNameServerName,port).c_str())
	{
	};

	//!ԡ󥹥ȥ饯
	RTCompControl(const RTCompControl& src)
	:ORBvarManager(),m_nameserver(src.m_nameserver),m_con(src.m_con),m_eclist(src.m_eclist)
	{
	};

	//!ǥȥ饯
	virtual ~RTCompControl()
	{
	};

	//!Set port
	void SetRTComponent(std::string ComponentName)
	{
		m_con.setObject(m_nameserver.resolve(ComponentName.c_str()));
	  m_eclist = m_con->get_execution_context_services();
	};

	//!Execute RTComponent Activate
	void Activate()
	{
	  m_eclist[0]->activate_component(RTC::RTObject::_duplicate(m_con._ptr()));
	};

	//!Execute RTComponent Deactivate
	void Deactivate()
	{
	  m_eclist[0]->deactivate_component(RTC::RTObject::_duplicate(m_con._ptr()));
	};

	//!Execute RTComponent Reset
	void Reset()
	{
	  m_eclist[0]->reset_component(RTC::RTObject::_duplicate(m_con._ptr()));
	};

	//!Setting name server
	void SetNameServer(std::string OmniNameServerName, long OmniPort = -1)
	{
		m_nameserver.init(NameAndPort2str( OmniNameServerName, OmniPort).c_str());
	};

	//!oeprator = 
	RTCompControl& operator=(const RTCompControl& right)
	{
		m_nameserver = right.m_nameserver;
		m_con        = right.m_con;
		m_eclist    = right.m_eclist;
		return *this;
	};

	protected:
	RTC::CorbaNaming                     m_nameserver;     //!<Corba Namerserver
	RTC::CorbaConsumer<RTC::RTObject>    m_con;            //!<Corba Consumer (RT Component)
  RTC::ExecutionContextServiceList_var m_eclist;        //!<Execute Context

	//!make string from port name and port number
	/**
	* @return corba port
	* @param name corba name server ip address
	* @param port corba name server port
	*/
	std::string NameAndPort2str(std::string name, long port)
	{
		if(port!=-1)
		{
			char PortStr[6];
			sprintf(PortStr,":%ld",port);
			name += PortStr;
		}
		return name;
	};
};

#endif
